<template>
  <v-alert
    v-if="isMessagesAvailable"
    v-model="show"
    :type="variant"
    dismissible
    dense
    class="metrocheck-alert"
    @click.stop.prevent="closeFlash"
  >
    <template v-slot:default>
      {{ message }}
    </template>
    <template v-slot:close="slotProps">
      <v-btn
        class="v-alert__dismissible"
        icon
        small
        @click.stop.prevent="closeFlash"
      >
        <v-icon>$cancel</v-icon>
      </v-btn>
    </template>
  </v-alert>
</template>

<script>
  export default {
    name: 'MetrocheckFlashAlert',
    props: {
      variant: {
        type: String,
        required: true,
      },
      important: {
        type: Boolean,
        default: false,
      },
      autoHide: {
        type: Boolean,
        default: false,
      },
      transitionName: {
        type: String,
        default: 'custom-classes-transition',
      },
      transitionIn: {
        type: String,
        default: 'animated fadeInDown',
      },
      transitionOut: {
        type: String,
        default: 'animated fadeOutUp',
      },
    },
    data () {
      return {
        message: null,
        closed: false,
        // eslint-disable-next-line vue/no-reserved-keys
        _timeout: null,
        // <String> the name used for registering vuex module
        namespace: 'FLASH',
        // <Number> duration of auto close flash message (in milliseconds)
        duration: 10000,
        // <Boolean> if false then clear persisted storage every time
        keep: true,
        // <Storage> persistant storage
        storage: null,
        // <String> persistant storage key
        key: '__vuexFlash',
        // <Array> custom css classes for template
      }
    },
    computed: {
      show: {
        get: function () { return !this.closed && !!this.message },
        set: function (value) { if (!value) { console.log('show setter closing flash'); this.closeFlash() } },
      },
      cleaner () {
        return `${this.namespace}/CLEAR_FLASH`
      },
      isMessagesAvailable () {
        return !this.$store.getters[this.getter('getFlashMessage')](this.variant)
      },
    },
    watch: {
      isMessagesAvailable: function () { return this.refresh() },
    },
    mounted () {
      this.refresh()
    },
    methods: {
      refresh () {
        const flashMsg = this.getFlash()

        if (flashMsg) {
          this.message = flashMsg
          this.closed = false
          this.clearFlash()
          if (this.autoHide) {
            this.autoClose()
          }
        }
      },
      getter (name) {
        return `${this.namespace}/${name}`
      },
      getFlash () {
        return this.$store.getters[this.getter('getFlashMessage')](this.variant)
      },
      closeFlash () {
        this.closed = true
        this.message = null

        if (this._timeout) {
          clearTimeout(this._timeout)
        }
      },
      // check if all flash messages have been flashed when use persist data and keep = false
      // useful when there are multiple flashes and have to clear persist storage every time
      flashed () {
        return this.$store.getters[this.getter('flashed')]
      },
      clearFlash () {
        // noinspection JSCheckFunctionSignatures
        this.$store.commit(this.cleaner, this.variant)

        if (!this.keep && this.flashed()) {
          this.clearPersisted()
        }
      },
      autoClose () {
        this._timeout = setTimeout(() => {
          this.closeFlash()
        }, this.duration)
      },
    },
  }
</script>

<style scoped>
  .v-alert {
    margin-bottom: 0;
  }
  .v-alert + .v-alert {
    margin-top: 16px
  }
  .metrocheck-alert button {
    margin-right: 66px;
  }
</style>
